> For the complete documentation index, see [llms.txt](https://docs.hypertensor.org/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.hypertensor.org/network/subnet-node/remove.md).

# Remove

Nodes can remove themselves from a subnet on-chain as long as they are not the current epoch's validator; otherwise, it will remove them from the current epoch's attestation data, if it exists.

#### Call `remove_subnet_node` to remove

```rust
pub fn remove_subnet_node(
    origin: OriginFor<T>, 
    subnet_id: u32, 
    subnet_node_id: u32,
)
```

#### Inserted & Updated Storage

```rust
...
// Remove node from attestations
...
PeerIdSubnetNode::<T>::remove(subnet_id, &peer_id);
BootstrapPeerIdSubnetNode::<T>::remove(subnet_id, subnet_node.bootstrap_peer_id);
HotkeySubnetNodeId::<T>::remove(subnet_id, &hotkey);
SubnetNodeIdHotkey::<T>::remove(subnet_id, subnet_node_id);

// Update total subnet peers by subtracting 1
TotalSubnetNodes::<T>::mutate(subnet_id, |n: &mut u32| n.saturating_dec());

// Reset sequential absent subnet node count
SubnetNodePenalties::<T>::remove(subnet_id, subnet_node_id);

TotalActiveNodes::<T>::mutate(|n: &mut u32| n.saturating_dec());
```

{% hint style="info" %}
When removed, the stake balance is not removed. This must be manually removed by calling [remove\_stake](/network/subnet-node/staking.md).
{% endhint %}


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.hypertensor.org/network/subnet-node/remove.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
